%define         sope_soname            4_9
%define         sope_version           4.9
%define         gs_library             %_libdir/GNUstep
%define         gs_makefiles           %_libdir/GNUstep/Makefiles
%define         oname                  SOGo
%define         grp                    sogo
%define         usr                    sogo
%global _legacy_common_support 1

%define         _disable_ld_no_undefined 1

%define bootstrap 1

Name:           sogo
Summary:        Scalable OpenGroupware.org (Inverse edition)
Version:        5.6.0
Release:        %mkrel 2
License:        GPLv2+ or LGPLv2+
Group:          Networking/Mail
Url:            https://www.sogo.nu/
Source0:        https://www.sogo.nu/files/downloads/SOGo/Sources/%{oname}-%{version}.tar.gz
Source1:        %{oname}.sysconfig
Source2:        %{oname}.init
Source3:        %{oname}.logrotate
Source4:        %{oname}.wrapper
Source100:      %{oname}.rpmlintrc
# set TABS
Patch1:         %{oname}-makefile.patch
# FIX install DESTDIR for versitCardsSaxDriver
Patch2:         %{oname}-DESTDIR.patch
# Fix error SOGo mail bundles not loading (could not load product: MailPartViewers)
Patch3:         %{oname}-5.6.0-makefile2.patch
# Fix Program returns random data in a function
Patch4:         %{oname}-SOGoContentObject.m.patch
#####
Patch5:         %{oname}-2.2.14-fix-openchange-link.patch

BuildRequires:  gcc-objc
#BuildRequires:  gnustep-base
BuildRequires:  gnustep-base-devel
BuildRequires:  gnustep-base
#BuildRequires:  gnustep-make
#BuildRequires:  apache
BuildRequires:  pkgconfig(libcurl)
BuildRequires:  pkgconfig(libmemcached)
#BuildRequires:  patch
BuildRequires:  sope-devel
BuildRequires:  pkgconfig(libytnef)
BuildRequires:  fdupes
BuildRequires:  pkgconfig(libsodium)
BuildRequires:  pkgconfig(libzip)
#
Requires:       gnustep-base
Requires:       apache
Requires:       memcached
Requires:       sope-appserver
Requires:       sope-core
#
Recommends:     cron
Recommends:     logrotate
Recommends:     tmpwatch

%description
SOGo is a groupware server built around OpenGroupware.org (OGo) and
the sope application server.  It focuses on scalability.

The Inverse edition of this project has many feature enhancements:
- CalDAV and GroupDAV compliance
- full handling of vCard as well as vCalendar/iCalendar formats
- support for folder sharing and ACLs

The Web interface has been rewritten in an AJAX fashion to provided a faster
UI for the users, consistency in look and feel with the Mozilla applications,
and to reduce the load of the transactions on the server.

%package -n libGDLContentStore%{sope_soname}
Summary:        Storage backend for folder abstraction
Group:          System/Libraries

%description -n libGDLContentStore%{sope_soname}
The storage backend implements the "low level" folder abstraction, which is
basically an arbitary "BLOB" containing some document.

%package -n libNGCards%{sope_soname}
Summary:        sope library for iCal and VCard formats
Group:          System/Libraries

%description -n libNGCards%{sope_soname}
sope versit parsing library for iCal and VCard formats

%package devel
Summary:        Development headers and libraries for SOGo
Group:          Development/C#
Requires:       %{name} = %{version}
Requires:       libGDLContentStore%{sope_soname} = %{version}
Requires:       libNGCards%{sope_soname} = %{version}
Requires:       libGDLAccess%{sope_soname} = %{version}

%description devel
Development headers and libraries for SOGo. Needed to create modules.

%package tool
Summary:        Command-line toolsuite for SOGo
Group:          Networking/Mail

%description tool
Administrative tool for SOGo that provides the following internal commands:
  backup          -- backup user folders
  restore         -- restore user folders
  remove-doubles  -- remove duplicate contacts from the user address books
  check-doubles   -- list user address books with duplicate contacts

%package slapd-sockd
Summary:        SOGo backend for slapd and back-sock
Group:          Networking/Mail

%description slapd-sockd
SOGo backend for slapd and back-sock, enabling access to private address books
via LDAP.

%prep
%setup -q -n %oname-%version
%patch2
%patch3 -p1

#####
# remove --rpath in GNUmakefile
for makefiledir in UI/Contacts UI/SOGoUI UI/MailerUI UI/Common UI/MailPartViewers \
 UI/PreferencesUI UI/MainUI UI/AdministrationUI UI/Scheduler \
 SoObjects/SOGo Main Tests/Unit Tools; do
   sed -i 's/^\(ADDITIONAL_LDFLAGS.*\)\(--rpath,\)\(.*\)//' ${makefiledir}/GNUmakefile
done
sed -i 's/^\(.*\)\(-Wl,-rpath,$(SOGO_SYSLIBDIR)\/sogo\)\(.*\)//' SoObjects/common.make
sed -i 's/^\(.*\)\(-Wl,-rpath,$(SOGO_SYSLIBDIR)\/sogo\)\(.*\)//' ActiveSync/common.make
cat SoObjects/common.make
# some SOGoDefaults
sed -i \
  -e 's,\(WOLogFile\ =\ "\).*\(";\),\1/var/log/%{oname}/sogo.log\2,' \
  -e 's,\(WOPidFile\ =\ "\).*\(";\),\1/var/run/%{oname}/sogo.pid\2,' \
  -e 's,\(SOGoMailSpoolPath\ =\ "\)/tmp\(";\),\1/var/spool/%{oname}\2,' \
  SoObjects/%{oname}/SOGoDefaults.plist

# fix perm
chmod 644 Scripts/*.sh

# ****************************** build ********************************
%build
. %{gs_makefiles}/GNUstep.sh
./configure \
  --disable-debug \
  --disable-strip

case %{_target_platform} in
ppc64-*)
  cc="gcc -m64";
  ldflags="-m64";;
*)
  cc="gcc";
  ldflags="";;
esac

make CC="$cc" LDFLAGS="$ldflags" messages=yes

%if ! %bootstrap
	pushd OpenChange
		make
        popd
%endif

# ****************************** install ******************************
%install

case %{_target_platform} in
ppc64-*)
  cc="gcc -m64";
  ldflags="-m64";;
*)
  cc="gcc";
  ldflags="";;
esac

make DESTDIR=%{buildroot} \
  GNUSTEP_INSTALLATION_DOMAIN=SYSTEM \
  CC="$cc" LDFLAGS="$ldflags" \
  install
mkdir -p %{buildroot}%{_sysconfdir}/init.d
mkdir -p %{buildroot}%{_sysconfdir}/cron.daily
mkdir -p %{buildroot}%{_sysconfdir}/ld.so.conf.d
mkdir -p %{buildroot}%{_localstatedir}/log/%{oname}
mkdir -p %{buildroot}%{_localstatedir}/spool/%{oname}
mkdir -p %{buildroot}%_sysconfdir/sysconfig/

install -D -m0644 Apache/%{oname}.conf %{buildroot}%{_sysconfdir}/apache2/conf.d/%{oname}.conf
cat > %{buildroot}%{_sysconfdir}/cron.daily/%{oname}.nu-tmpwatch << "EOF"
#!/bin/sh
if [ -x /usr/sbin/tmpwatch ]; then
  /usr/sbin/tmpwatch 24 /var/spool/%{oname}
else
  echo "missing tool: tmpwatch"
fi
EOF
echo %{_libdir}/sogo > %{buildroot}%{_sysconfdir}/ld.so.conf.d/%{oname}.conf
install -D -m0644 %{S:1} %{buildroot}%_sysconfdir/sysconfig/%oname
install -D -m0755 %{S:2} %{buildroot}%{_sysconfdir}/init.d/sogod
install -D -m0644 %{S:3} %{buildroot}%{_sysconfdir}/logrotate.d/%{oname}
install -D -m0755 %{S:4} %{buildroot}%{_sbindir}/sogod-wrapper
chmod 755 %{buildroot}%{_sbindir}/sogod
chmod 755 %{buildroot}%{_sysconfdir}/cron.daily/%{oname}.nu-tmpwatch
ln -sf ../../etc/init.d/sogod %{buildroot}%{_sbindir}/rcsogod

%fdupes %{buildroot}%{gs_library}

# **************************** pkgscripts *****************************
%pre
# add group
%{_sbindir}/groupadd -r %{grp} 2>/dev/null || :
# add user
%{_sbindir}/useradd -c "%{oname} account" -d /var/lib/%{oname} -G %{grp} -g %{grp} \
  -r -s /bin/false %{usr} 2>/dev/null || :

%preun

%post
#if ! id sogo >& /dev/null; then /usr/sbin/useradd sogo > /dev/null 2>&1; fi
#if ! [ -d ~sogo ]; then /bin/mkdir ~sogo > /dev/null 2>&1; fi
#touch ~sogo/.profile
#grep -q '^source %{gs_makefiles}/GNUstep.sh' ~sogo/.profile || echo "source %{gs_makefiles}/GNUstep.sh" >> ~sogo/.profile
#/bin/chown -R sogo ~sogo
#/bin/chown -R sogo /var/log/sogod
#/bin/chown -R sogo /var/spool/sogod
#/bin/chmod 700 /var/spool/sogod

%postun
#
#if test "$1" = "0"
#then
#  if [ -e ~sogo/.profile ]; then
#    mv -f ~sogo/.profile ~sogo/.profile.orig
#    egrep -v "^source %{gs_makefiles}/GNUstep.sh" ~sogo/.profile.orig > ~sogo/.profile
#    rm -f ~sogo/.profile.orig
#    /bin/chown sogo ~sogo/.profile
#  fi
#  /usr/sbin/userdel sogo
#  /usr/sbin/groupdel sogo > /dev/null 2>&1
#  /bin/rm -rf /var/spool/sogod
#fi

# ****************************** files ********************************
%files
%doc ChangeLog COPYING.*
%doc Scripts/sql-update-20070724.sh
%doc Scripts/sql-update-20070822.sh
%doc Scripts/sql-update-20080303.sh
%doc Scripts/sql-update-101_to_102.sh
%dir %{_sysconfdir}/apache2/
%dir %{_sysconfdir}/apache2/conf.d
%config(noreplace) %{_sysconfdir}/apache2/conf.d/%{oname}.conf
%config %_sysconfdir/sysconfig/%oname
%config %{_sysconfdir}/cron.daily/%{oname}.nu-tmpwatch
%config %{_sysconfdir}/logrotate.d/%{oname}
%config %{_sysconfdir}/ld.so.conf.d/%{oname}.conf
%{_sysconfdir}/init.d/sogod
%{_sbindir}/sogod
%{_sbindir}/sogod-wrapper
%{_sbindir}/rcsogod
%attr(750,%{usr},root) %{_localstatedir}/log/%{oname}
%attr(750,%{usr},root) %{_localstatedir}/spool/%{oname}
%dir %{_libdir}/sogo
%{_libdir}/sogo/libSOGo.so.*
%{_libdir}/sogo/libSOGoUI.so.*
%dir %{gs_library}/Frameworks
%dir %{gs_library}/Frameworks/%{oname}.framework
%dir %{gs_library}/Frameworks/%{oname}.framework/sogo
%{gs_library}/Frameworks/%{oname}.framework/Resources
%dir %{gs_library}/Frameworks/%{oname}.framework/Versions
%dir %{gs_library}/Frameworks/%{oname}.framework/Versions/5
%dir %{gs_library}/Frameworks/%{oname}.framework/Versions/5/sogo
%{gs_library}/Frameworks/%{oname}.framework/Versions/5/sogo/libSOGo.so.*
%{gs_library}/Frameworks/%{oname}.framework/Versions/5/Resources
%{gs_library}/Frameworks/%{oname}.framework/Versions/Current
%dir %{gs_library}/%{oname}
%{gs_library}/%{oname}/*.%{oname}
%{gs_library}/%{oname}/Templates
%{gs_library}/%{oname}/WebServerResources
%{gs_library}/OCSTypeModels
%{gs_library}/WOxElemBuilders-%{sope_version}

%files tool
%{_sbindir}/sogo-tool
%{_sbindir}/sogo-ealarms-notify

%files slapd-sockd
%{_sbindir}/sogo-slapd-sockd

%files -n libGDLContentStore%{sope_soname}
%{_libdir}/sogo/libGDLContentStore*.so.%{sope_version}{,.*}

%files -n libNGCards%{sope_soname}
%{_libdir}/sogo/libNGCards.so.*
%{gs_library}/SaxDrivers-%{sope_version}
%{gs_library}/SaxMappings
%{gs_library}/Libraries/Resources

%files devel
%{_includedir}/%{oname}
%{_includedir}/SOGoUI
%{_libdir}/sogo/libSOGo.so
%{_libdir}/sogo/libSOGoUI.so
%{_libdir}/sogo/libNGCards.so
%{gs_library}/Frameworks/%{oname}.framework/Headers
%{gs_library}/Frameworks/%{oname}.framework/sogo/libSOGo.so
%{gs_library}/Frameworks/%{oname}.framework/sogo/%{oname}
%{gs_library}/Frameworks/%{oname}.framework/Versions/5/Headers
%{gs_library}/Frameworks/%{oname}.framework/Versions/5/sogo/libSOGo.so
%{gs_library}/Frameworks/%{oname}.framework/Versions/5/sogo/%{oname}
# ***** LibGDLContentStore *****
%{_includedir}/GDLContentStore
%{_libdir}/sogo/libGDLContentStore*.so
# ***** LibNGCards *****
%{_includedir}/NGCards





%changelog
* Tue Dec 06 2022 daviddavid <daviddavid> 5.6.0-2.mga9
+ Revision: 1918620
- rebuild for new gnustep-base 1.28.0

* Tue May 24 2022 papoteur <papoteur> 5.6.0-1.mga9
+ Revision: 1859976
- new 5.6.0 (mga#29255)

* Wed Apr 06 2022 umeabot <umeabot> 5.1.1-3.mga9
+ Revision: 1845909
- Mageia 9 Mass Rebuild

* Sat Oct 02 2021 wally <wally> 5.1.1-2.mga9
+ Revision: 1747497
- rebuild for openssl 3.0.0
+ neoclust <neoclust>
- New version 5.1.1 (Fixes CVE-2021-33054) mga#29255

* Mon Dec 14 2020 neoclust <neoclust> 5.0.1-1.mga8
+ Revision: 1657069
- New version 5.0.1
+ joequant <joequant>
- fix gcc10 build

* Sun Feb 16 2020 umeabot <umeabot> 4.0.0-4.mga8
+ Revision: 1534805
- Mageia 8 Mass Rebuild

* Sun Oct 06 2019 daviddavid <daviddavid> 4.0.0-3.mga8
+ Revision: 1449931
- rebuild for gnustep-base 1.26.0

* Sun Sep 23 2018 umeabot <umeabot> 4.0.0-2.mga7
+ Revision: 1301100
- Mageia 7 Mass Rebuild

* Wed Mar 28 2018 kekepower <kekepower> 4.0.0-1.mga7
+ Revision: 1213062
- Update to version 4.0.0

* Wed Sep 06 2017 cjw <cjw> 3.2.8-4.mga7
+ Revision: 1151639
- rebuild for openssl 1.1

* Wed Apr 26 2017 neoclust <neoclust> 3.2.8-3.mga6
+ Revision: 1097466
- New version - Fixes (CVE-2016-618[89], CVE-2016-619[01], CVE-2014-9905) (mga#18697)

* Wed Feb 17 2016 umeabot <umeabot> 2.3.1-3.mga6
+ Revision: 962867
- Mageia 6 Mass Rebuild

* Mon Oct 26 2015 daviddavid <daviddavid> 2.3.1-2.mga6
+ Revision: 895571
- turn off stripping of debug symbols to fix empty debuginfo
- fix License

* Tue Aug 04 2015 neoclust <neoclust> 2.3.1-1.mga6
+ Revision: 860946
- New version 2.3.1

* Thu Jul 09 2015 neoclust <neoclust> 2.3.0-1.mga6
+ Revision: 853048
- New version 2.3.0
- imported package sogo


* Mon Feb 02 2015 nlecureuil <nlecureuil> 2.2.15-1.mbs1
+ Revision: 146440
- New version 2.2.15

* Wed Jan 28 2015 nlecureuil <nlecureuil> 2.2.14-2.mbs2
+ Revision: 146259
- Fix libs symlinks

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-1.mbs2
+ Revision: 145977
- imported package sogo

